#include <dotneato.h>
#include <stdlib.h>
#include <assert.h>
#include <time.h>
#include "binTree.h"
Agraph_t * g;
void modifierAttr(void * obj, char type, char * attr, char * value) {
  Agsym_t * a;
  if(!(a = agfindattr(g->proto->n, attr)))
    switch(type) {
    case 'n': a = agnodeattr(g, attr, ""); break;
    case 'e': a = agedgeattr(g, attr, ""); break;
    default: break;
    }
  agxset(obj, a->index, value);
}
void ajouterNoeud(Agnode_t * parent, int v, AB * apartir, char * pos) {
  static int count = 0;
  char buf[BUFSIZ];
  sprintf(buf, "n%d", count);
  *apartir = malloc(sizeof (*apartir)[0]); assert(*apartir);
  (*apartir)->v = v; (*apartir)->fg =(*apartir)->fd = NULL;
  (*apartir)->n = agnode(g, buf);
  modifierAttr((*apartir)->n, 'n', "shape", "record");
  modifierAttr((*apartir)->n, 'n', "width", "2.0");
  sprintf(buf, "{%d|{<fg>|<fd>}}", v);
  modifierAttr((*apartir)->n, 'n', "label", buf);
  if(parent) {
    Agedge_t * e;
    modifierAttr(e = agedge(g, parent, (*apartir)->n), 'e', "tailport", pos);
    modifierAttr(e, 'e', "arrowhead", "none");
  }
  count++;
}
void placerNoeud(Agnode_t * parent, int v, AB * apartir, char * pos) {
  if(*apartir == NULL)
    ajouterNoeud(parent, v, apartir, pos);
  else if((*apartir)->v >= v)
    placerNoeud((*apartir)->n, v, &((*apartir)->fg), "fg");
  else
    placerNoeud((*apartir)->n, v, &((*apartir)->fd),  "fd");
}
void initArbre(AB * pracine) {
  int i, t[NB_NOEUDS], j, k = 0;
  srand(time(NULL));
  for(i = 0; i < NB_NOEUDS; i++) t[i] = i + 1;
  for(i = 0; i < NB_NOEUDS; i++) {
    j = ALEA; while(k == j) k = ALEA;
    t[j] ^= t[k]; t[k] ^= t[j]; t[j] ^= t[k];
  }
  for(i = 0; i < NB_NOEUDS; i++)
    placerNoeud(NULL, t[i], pracine, "");
}
void parcourtPrefix(AB apartir) {
  static AB precedent = NULL;
  if(apartir->fg)
    parcourtPrefix(apartir->fg);
  if(precedent)
    modifierAttr(agedge(g, precedent->n, apartir->n), 'e', "style", "dotted");
  precedent = apartir;
  if(apartir->fd)
    parcourtPrefix(apartir->fd);
}
int main(int argc, char ** argv) {
  GVC_t    * gvc;
  AB racine = NULL;
  gvc = gvContext();
  dotneato_initialize(gvc, argc, argv);
  g = agopen("g", AGDIGRAPH);
  initArbre(&racine);
  parcourtPrefix(racine);
  gvBindContext(gvc, g);
  dot_layout(g);
  dotneato_write(gvc);
  neato_cleanup(g);
  agclose(g);
  dotneato_terminate(gvc);
  return 0;
}
