#include <dotneato.h>
#include <sys/types.h>
#include <dirent.h>
#include <stdio.h>
#include <string.h>
Agraph_t * g;
void modifierAttr(void * obj, char type, char * attr, char * value) {
  Agsym_t * a;
  if(!(a = agfindattr(g->proto->n, attr)))
    switch(type) {
    case 'n': a = agnodeattr(g, attr, ""); break;
    case 'e': a = agedgeattr(g, attr, ""); break;
    default: break;
    }
  agxset(obj, a->index, value);
}
int recuDir(char * path, char * name, Agnode_t * parent) {
  DIR * dir;
  char buf[BUFSIZ];
  struct dirent * dirent;
  Agnode_t * n;
  n = agnode(g, path);
  modifierAttr(n, 'n', "label", name);
  if(parent)
    agedge(g, parent, n);
  if((dir = opendir(path)) == NULL) return 0;
  while((dirent = readdir(dir))) {
    if(!strcmp(dirent->d_name, ".") || !strcmp(dirent->d_name, "..")) continue;
    sprintf(buf, "%s/%s", path, dirent->d_name);
    recuDir(buf, dirent->d_name, n);
  }
  closedir(dir);
  return 1;
}
int main(int argc, char ** argv) {
  GVC_t    * gvc;
  if(argc < 2) {
    fprintf(stderr, "usage : %s path [dot options]\n", argv[0]);
    exit(1);
  }
  gvc = gvContext();
  dotneato_initialize(gvc, argc, argv);
  g = agopen("g", AGDIGRAPH);
  recuDir(argv[1], ".", NULL);
  gvBindContext(gvc, g);
  dot_layout(g);
  dotneato_write(gvc);
  neato_cleanup(g);
  agclose(g);
  dotneato_terminate(gvc);
  return 0;
}
